
/*! \file *********************************************************************
 *
 * 쌠 (C) 2012-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 * \brief  ATmega162 SPI呕u ̧
 *
 * ̧ق͑SĂ̗̺ނ܂݂܂B؂ւɂ͑Ήٰ݂̌Ăяo
 * Ȃ΂Ȃ܂B
 * (main۸т̒߂B)
 *
 *	ײނ͂̊֐̺ލsŁA֐Ăяo̊Ԑڕׂނ
 *	\邽߁A傫⑬x厖ȺޗpɈӐ}܂Bײނ
 *	AT162 SPI呕un߂邽߂̑fƎړIӐ}܂B
 *
 *	傫⑬x厖ȺނɊւẮA֐ĂяoɊ֐e
 *	ړIɉp֕ʂ邱Ƃ܂B
 *
 * \par pLq:
 *	AVR151: SPȈݒƎgp
 *
 * \par 
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *
 *	xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 *****************************************************************************/
 

#include <avr/io.h>
#include <avr/interrupt.h>


char*	textstring		= "A";
char*	ptr_to_strchar;			// ʒuwq
char	clear_to_send	= 1;	// M(񑗐M)׸

// 呕u쏉ٰ(߰ݸޗp)
void init_master (void)
{
	volatile char IOReg;

	DDRB	= (1<<PB4)|(1<<PB5)|(1<<PB7);	// PB4(/SS),PB5(MOSI),PB7(SCK)o͐ݒ
	SPCR	= (1<<SPE)|(1<<MSTR);			// CK/4,呕uSPI
	IOReg	= SPSR;							// SPIڼ޽SPI荞ݗv׸(SPIF)(0)
	IOReg	= SPDR;
}

// 呕u쏉ٰ(荞ݐp)
void init_master_intcontr (void)
{
	volatile char IOReg;

	DDRB	= (1<<PB4)|(1<<PB5)|(1<<PB7);				// PB4(/SS),PB5(MOSI),PB7(SCK)o͐ݒ
	SPCR	= (1<<SPIE)|(1<<SPE)|(1<<MSTR)|(1<<SPR0);	// CK/16,呕uSPI,SPI荞݋
	IOReg	= SPSR;										// SPIڼ޽SPI荞ݗv׸(SPIF)(0)
	IOReg	= SPDR;
	sei();
}

// 呕u쑗Mٰ(߰ݸޗp)
void master_send (void)
{
	ptr_to_strchar  = textstring;		// ʒuwq
	while (*ptr_to_strchar != 0)		// Iq(0)܂Ōp
	{
		SPDR = *ptr_to_strchar;			// Ή޲SPI]Jn
		while (!(SPSR & (1<<SPIF)));	// 1޲ē]ҋ@
		ptr_to_strchar++;				// ʒuwqis
	}
}

// 呕u쑗Mٰ(荞ݐp)
void master_send_IntContr (void)
{
	if (clear_to_send == 1)				// MȂA
	{
		ptr_to_strchar  = textstring;	// ʒuwq
		SPDR = *ptr_to_strchar;			// 擪޲SPI]Jn(ȍ~޲Ă͊荞ݏ)
		clear_to_send = 0;				// M׸މ(dMp)
	}
}

// 呕u슄荞ݏٰ(荞ݐp)
ISR(SPI_STC_vect)
{
	ptr_to_strchar++;				// ʒuwqis
	if (*ptr_to_strchar != 0)		// Iq(0)łȂ΁A
	{
		SPDR = *ptr_to_strchar;		// Ή޲ĂSPI]Jn
	}
	else clear_to_send = 1;			// Iqŕ񑗐M(M)׸ސݒ
}

int main(void)
{
	char keypressed	= 0x00;		// 񌟒m׸

	DDRD	= 0xFF;				// ߰đSޯďo͐ݒ
	PORTD	= 0x00;				// ߰đSޯLowo͐ݒ
/* ȉ2sŁAgpȂ̍s𒍎߂ɂĂB */
	init_master ();				// 1p:SPI(߰ݸޗp)
//	init_master_intcontr();		// 2p:SPI(荞ݐp)
	while (1)					// JԂ
	{
		if (PINA != 0xFF)			// ߰ẢꂩޯĂLowȂA
		{
			if (keypressed == 0x00)		// ߰ALow񌟒mȂA
			{
				keypressed = 0x01;		// 񌟒m׸ސݒ
				PORTD = ~PORTD;			// ߰Do͘_]
/* ȉ2sŁAgpȂ̍s𒍎߂ɂĂB */
				master_send ();			// 1p:呕u앶񑗐M(߰ݸޗp)
//				master_send_IntContr();	// 2p:呕u앶񑗐M(荞ݐp)
			}
		}
		else keypressed = 0x00;		// ߰ASޯ=HighȂA񌟒m׸މ
	}
	return 0;
}
